package net.sf.mgp.unclasses;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

class DependencyGraph {
	private final Map<String, Boolean> referencedClasses = new HashMap<String, Boolean>();
	
	public DependencyGraph(Collection<String> classNames) {
		for (String className : classNames) {
			referencedClasses.put(className, Boolean.FALSE);
		}
	}
	
	
	public void reference(String className) {
		if(referencedClasses.containsKey(className)) {
			referencedClasses.put(className, Boolean.TRUE);
		}
	}
	
	public Collection<String> getUnreferenced() {
		List<String> result = new ArrayList<String>();
		for (Entry<String, Boolean> entry : referencedClasses.entrySet()) {
			if(!entry.getValue()) {
				result.add(entry.getKey());
			}
		}
		return result;
	}
}
